//-----------------------------------------------------------------------------
// Example program for VISA.
// Written by Maple Eagle.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------
#include <visa.h>
#include <visatype.h > 
//#include <utility.h>
#include <ansi_c.h>
#include <cvirte.h>     
#include <userint.h>
#include "demo.h"
//-----------------------------------------------------------------------------
// Global variables
//-----------------------------------------------------------------------------
static int panel;
//-----------------------------------------------------------------------------
// Refresh devices function
//-----------------------------------------------------------------------------
int Getdevs()
{
	char buf [256] = {0};
	int i,j=0;
	long Vireturn;
	ViSession defaultRM,vi; 
	ViChar buffer [VI_FIND_BUFLEN];
	ViRsrc matches=buffer;
	ViUInt32 nmatches;
	ViFindList list;
	viOpenDefaultRM(&defaultRM);
	viFindRsrc(defaultRM, "?*", &list,&nmatches, matches);
	viOpen (defaultRM,matches,VI_NULL,VI_NULL,&vi);
	viPrintf (vi, "*IDN?\n");
	viScanf(vi,"%t\n", &buf);
	if (strlen(buf)>1) 
	{
		InsertListItem (panel,PANEL_RING,-1,matches,j++);
	}
	viClose(vi);
    for (i=1;i<nmatches;i++) 
		{
			
			viFindNext(list,matches);
			viOpen (defaultRM,matches,VI_NULL,VI_NULL,&vi);
			viPrintf (vi, "*IDN?\n");
//			viSetAttribute(vi, VI_ATTR_TMO_VALUE, VI_TMO_INFINITE);
			memset(buf,   0,   sizeof(buf)); 
			viScanf(vi,"%t\n", &buf);
			if (strlen(buf)>1) 
			{
				InsertListItem (panel,PANEL_RING,-1,matches,j++);              
			}
			
			viClose(vi);
		}	
	viClose(defaultRM);
	return 0;
}
//-----------------------------------------------------------------------------
// Entry-point function
//-----------------------------------------------------------------------------
int main (int argc, char *argv[])
{
    if (InitCVIRTE (0, argv, 0) == 0)
        return -1;
    if ((panel = LoadPanel (0, "demo.uir", PANEL)) < 0)
        return -1;
    DisplayPanel (panel);
	Getdevs ();
    RunUserInterface ();
//	ButtonCallback_rf();
    DiscardPanel (panel);
    return 0;
}

//-----------------------------------------------------------------------------
// User-interface callback functions
//-----------------------------------------------------------------------------
int CVICALLBACK PanelCallback (int panel, int event, void *callbackData,
        int eventData1, int eventData2)
{
    switch (event)
    {
        case EVENT_CLOSE:
            QuitUserInterface (0);
            break;
    }
    return 0;
}


int CVICALLBACK ButtonCallback_so(int panel,int control,int event,
		void *callbackData, int eventData1, int eventData2)
{   
	char buf [256] = {0};
	int i;
	ViSession defaultRM,vi; 
	ViChar buffer [VI_FIND_BUFLEN];
	ViRsrc matches=buffer;
	ViUInt32 nmatches;
	ViFindList list;
	switch (event)
	{
		case EVENT_LEFT_CLICK:
			 viOpenDefaultRM(&defaultRM);
			 viFindRsrc(defaultRM, "?*", &list,&nmatches, matches);
			 viOpen (defaultRM,matches,VI_NULL,VI_NULL,&vi);
			 GetCtrlVal(panel,PANEL_CMD,buf);
			 sprintf(&buf[strlen(buf)], "%c ",10);
			 viPrintf (vi, buf);
			 viClose(vi);
			 viClose(defaultRM);
	}
	
	return 0;	
}

int CVICALLBACK ButtonCallback_sr(int panel,int control,int event,
		void *callbackData, int eventData1, int eventData2)
{   
	char buf [256] = {0};
	int i;
	ViSession defaultRM,vi; 
	ViChar buffer [VI_FIND_BUFLEN];
	ViRsrc matches=buffer;
	ViUInt32 nmatches;
	ViFindList list;
	switch (event)
	{
		case EVENT_LEFT_CLICK:
			 viOpenDefaultRM(&defaultRM);
			 viFindRsrc(defaultRM, "?*", &list,&nmatches, matches);
			 viOpen (defaultRM,matches,VI_NULL,VI_NULL,&vi);
			 GetCtrlVal(panel,PANEL_CMD,buf);
			 sprintf(&buf[strlen(buf)], "%c ",10);
			 viPrintf (vi, buf);
			 viScanf(vi,"%t\n", &buf);
			 DefaultCtrl(panel,PANEL_TEXTBOX);
			 SetCtrlVal(panel, PANEL_TEXTBOX, buf);          
			 viClose(vi);
			 viClose(defaultRM);
	}
	
	return 0;	
}

int CVICALLBACK ButtonCallback_rf(int panel,int control,int event,
		void *callbackData, int eventData1, int eventData2)
{   

	switch (event)
	{
		case EVENT_LEFT_CLICK:
       		 Getdevs ();

	}
	
	return 0;	
}
//-----------------------------------------------------------------------------      


